package fr.iut.sciencequest.sae.dto.indice;

import com.fasterxml.jackson.annotation.JsonInclude;
import fr.iut.sciencequest.sae.dto.scientifique.ScientifiqueDTO;
import jakarta.validation.Valid;
import jakarta.validation.constraints.NotBlank;
import jakarta.validation.constraints.NotNull;
import lombok.*;
import org.springframework.hateoas.RepresentationModel;


@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@EqualsAndHashCode(callSuper = false)
@JsonInclude(JsonInclude.Include.NON_NULL)
public class IndiceDTO extends RepresentationModel<IndiceDTO> {
    @NotNull
    private Integer id;

    @NotBlank
    private String libelle;

    @NotNull
    private ScientifiqueDTO scientifique;
}
