package fr.iut.sciencequest.sae.dto.utilisateur;

import com.fasterxml.jackson.annotation.JsonInclude;
import jakarta.validation.constraints.Email;
import jakarta.validation.constraints.NotBlank;
import jakarta.validation.constraints.NotNull;
import lombok.*;
import org.springframework.hateoas.RepresentationModel;


@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@EqualsAndHashCode(callSuper = false)
@JsonInclude(JsonInclude.Include.NON_NULL)
public class UtilisateurDTO extends RepresentationModel<UtilisateurDTO> {
    @NotNull
    private Integer id;

    @Email
    @NotNull
    private String email;

    @NotBlank
    private String pseudo;

}
